       SUBROUTINE bgcatm
!
#if defined key_trc_atmco2
!
!-----------------------------------------------------------------------
!
!      Calculates the atmospheric CO2 concentration
!
!-----------------------------------------------------------------------
!
      USE trp_trc
      USE sms
      USE oce_trc
      IMPLICIT NONE
!
      INTEGER iyy,is
      REAL zyr,slope,inter
!
      iyy = ndastp/10000
      zyr = float(iyy) + (float(nday_year)-0.5)/365.
!
      IF (zyr .lt. yrco2(1) .OR. zyr .gt. yrco2(nmaxrec)) THEN
        IF(lwp) THEN
         write(numout,*)'Caution: The date is outside tabulated values.'
         write(numout,*)'zyr, zyr(min) zyr(max) = ', zyr, yrco2(1),yrco2(nmaxrec)
         write(numout,*)'approximate pCO2'
        ENDIF
        pco2at = 278+0.00009*max(zyr-1870.,0.)**2.847
      ENDIF
      DO is = 1, nmaxrec-1
        IF(zyr.ge.yrco2(is) .AND. zyr.le.yrco2(is+1)) THEN
          slope = (sipco2(is+1) - sipco2(is)) /(yrco2(is+1) - yrco2(is))
          inter = sipco2(is)-slope*yrco2(is)
          pco2at = slope*zyr + inter
          pn2oat = (9.47135337652248E-6*zyr**3 -0.0521471393403346*zyr**2&
     &      + 95.6806624804179*zyr -58228.4121017423)*1e-9
          EXIT
        ENDIF
      END DO
      IF(lwp) WRITE(numout,*) 'Atmospheric xCO2, xN2O concentrations: ',&
     &  ndastp,zyr,pco2at,pn2oat*1e9
#endif
      RETURN
      END
