#if defined key_top
      SUBROUTINE bgcint(kt)
!
      USE trp_trc
      USE sms
      USE trc
      USE oce_trc
      USE dom_oce , ONLY :   gphit      =>   gphit      !: latitude  of t-point (degre)
      USE dom_oce , ONLY :   hdept      =>  hdept       !: bottom depth of t-points (m)
      USE daymod  , ONLY :   nmonth    =>   nmonth      !: Current month
      USE sbc_oce , ONLY :   fr_i      =>   fr_i        !: ice fraction (between 0 to 1)
      IMPLICIT NONE
      INTEGER kt
      INTEGER ji, jj, jk, jl
      INTEGER ipdtant, nvit1t, nvit2t, lecvit, nimon1, nimon2
      REAL    zpdtan, zpdtmo, zdemi, zt, ztmax  
      REAL    ztopt, zdt
      REAL    zice1, zice2, zfacti, zfactl, zfactd, zmonth, ztemp
#  include "domzgr_substitute.h90"
!
      lecvit = 12
      ipdtant  = (12*730*60*60)/int(rdttra(1))
!
      zpdtan = float ( ipdtant)
      zpdtmo = zpdtan / float ( lecvit)
      zdemi  = zpdtmo / 2.
      zt     = ( float ( kt) + zdemi) / zpdtmo
      
!  recherche de l'indice des enregistrements
!  du modele dynamique encadrant le pas de temps kt.
!  --------------------------------------------------
!
      xtvit = zt - int ( zt)
      nvit1t = int (( float ( kt) + zdemi)/ zpdtmo)
      nvit2t = nvit1t+1
      nvit1t = MOD ( nvit1t+11, lecvit)+1
      nvit2t = MOD ( nvit2t+11, lecvit)+1
!
      zpdtmo=(kt+1314000/rdttra(1))/ipdtant
      zpdtan=(nit000+1314000/rdttra(1))/ipdtant
      nimon1=int((zpdtmo-int(zpdtan))*lecvit)+1
      nimon2=int((zpdtmo-int(zpdtan))*lecvit)+2
!      IF(lwp .AND. MOD(kt,15)==0) WRITE(numout,*) "bgcint ",nvit1t,nvit2t&
      IF(lwp) WRITE(numout,*) "bgcint ",nvit1t,nvit2t&
     &,nimon1,nimon2,xtvit
!
          DO jj = 2, nlcj-1
            DO ji = 2, nlci-1
              dust(ji,jj) = (1.-xtvit)*dustmo(ji,jj,nvit1t) &
     &            +xtvit*dustmo(ji,jj,nvit2t)
              depno3(ji,jj,1) = ((1.-xtvit)*atmnoy(ji,jj,nimon1)        &
     &            +xtvit*atmnoy(ji,jj,nimon2))/14./fse3t(ji,jj,1)       &
     &            *rfact+depnit(ji,jj,1)
              depnh4(ji,jj,1) = (((1.-xtvit)*atmnhx(ji,jj,nimon1)       &
     &            +xtvit*atmnhx(ji,jj,nimon2))+((1.-xtvit)              &
     &            *atmdon(ji,jj,nvit1t)+xtvit*atmdon(ji,jj,nvit2t))&
     &            /1000./rmoss)/14./fse3t(ji,jj,1)*rfact
            END DO
          END DO
!
! For all pft's - including bacteria
!
       DO jl = jpmic, jpdia+jppft
         DO jk = 1, jpkm1
           DO jj = 2, nlcj-1
             DO ji = 2, nlci-1
!
! this is exponential growth 
!
                 tgfunc(ji,jj,jk,jl) = (rn_mutpft(jl))**(tn(ji,jj,jk))
!
             END DO
           END DO
         END DO
       END DO
!
! coccolithophorids growth is fixed to optimal temperature when the namelist shows zero T-dependence of growth (rn_mutpft)
!
       ztopt   = 19.5
       zdt     = 10.20
       ztemp = 10.
!
       DO jk = 1, jpkm1
         DO jj = 2, nlcj-1
           DO ji = 2, nlci-1
! for reduced growth below ztemp: 
             ztmax = (1./5. + 4./5.*tn(ji,jj,jk)/(ztemp+rtrn))*(rn_mutpft(jpcoc))**(tn(ji,jj,jk))
             tgfunc(ji,jj,jk,jpcoc) = min(ztmax,tgfunc(ji,jj,jk,jpcoc))
!
           END DO
         END DO
       END DO
!
! increase the growth rate of mac when ice is between 0.1-0.3 to represent enhanced recruitment
! as in Wiedenmann et al., Limnology and Oceanography 2009
!
       DO jk = 1, jpkm1
         DO jj = 2, nlcj-1
           DO ji = 2, nlci-1
!
! zfacti is 1 when ice is greater then 0.1 and less than 0.3 and 0 otherwise 
!
             zice1  = fr_i(ji,jj)-0.1
             zice2  = fr_i(ji,jj)-0.3
             zfacti = max(0.,zice1)/(zice1+rtrn) * min(0.,zice2)/(zice2+rtrn)
!
! zfactl is 1 during Aug-Nov in the SH and Feb-May in the NH and 0 otherwise
!
             zmonth = float(nmonth)
             zfactl =  min(gphit(ji,jj),0.)/gphit(ji,jj) *                 & 
     &                    (max(0.,(zmonth-7.))/(zmonth-7.+rtrn)) *         &
     &                    (min(0.,(zmonth-12.))/(zmonth-12.+rtrn)) +       &
     &                 max(gphit(ji,jj),0.)/gphit(ji,jj) *                 &
     &                    (max(0.,(zmonth-1.))/(zmonth-1.+rtrn)) *         &
     &                    (min(0.,(zmonth-6.))/(zmonth-6.+rtrn))                    
!
! zfactd is 1 when the depth does not exceed 600 m and 0 otherwise
!
!            zfactd = min(0.,gdept(ji,jj,jk)-600.)/(gdept(ji,jj,jk)-600.+rtrn)
!
             zfactd = min(0.,hdept(ji,jj)-600.)/(hdept(ji,jj)-600.+rtrn)
!
! multiply growth by a factor rn_icemac (from Figure 4 in Wiedeman) when the above conditions are true
!
             tgfunc(ji,jj,jk,jpmac) = max(1.,zfacti*zfactl*zfactd*rn_icemac)*    &
     &                                tgfunc(ji,jj,jk,jpmac)
!
           END DO
         END DO
       END DO
!
! define coastal region (1. for depth = 0., linearly increasing to 0 to 1000 or deeper)
!
       DO jj = 1, nlcj
         DO ji = 1, nlci
!
           rcoast(ji,jj) = min(0.,hdept(ji,jj)-1000.)/(-1000.)
!
         END DO
       END DO
!
! assign susceptibility to advection (rn_trnmac) in coastal or ice-covered areas
!
       DO jj = 1, nlcj
         DO ji = 1, nlci
!
! zfacti is rn_trnmac when ice is greater then 0.1 and 1 otherwise 
!
           zice1  = fr_i(ji,jj)-0.1
           zfacti = 1. - max(0.,zice1)/zice1*rn_trnmac 
!
! trnmac is rn_trnmac in shelf regions (<600 m), 1 otherwise
!
           trnmac(ji,jj) = 1. - min(0.,hdept(ji,jj)-600.)/(hdept(ji,jj)-600.+rtrn)*rn_trnmac
!
! combine ice and shelf effect
!
           trnmac(ji,jj) = min(trnmac(ji,jj),zfacti)
!
         END DO
       END DO
!
      RETURN
#endif
      END
