MODULE sms
!!---------------------------------------------------------------------
!!  TOP 1.0,  LOCEAN-IPSL (2005)
!! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
!!----------------------------------------------------------------------
#if defined key_top
   USE par_oce
   USE par_trc
   USE par_sms
   IMPLICIT NONE
   PUBLIC
!!----------------------------------------------------------------------
!!
!! COMMON/cchem1/ : Variable for chemistry of the CO2 cycle
!!
!! ---------------------------------------------------------------------
!!
      REAL, PUBLIC :: akb3(jpi,jpj,jpk), ak13(jpi,jpj,jpk), ak23(jpi,jpj,jpk)
      REAL, PUBLIC :: aksp(jpi,jpj,jpk), co3(jpi,jpj,jpk), hi(jpi,jpj,jpk)
      REAL, PUBLIC :: borat(jpi,jpj,jpk), hco3(jpi,jpj,jpk)
!!
!!----------------------------------------------------------------------
!!
!! COMMON/cchem2/ : Variable for chemistry of the CO2 cycle
!!
!! ---------------------------------------------------------------------
!!
! 
      REAL, PUBLIC :: atcox,h2co3(jpi,jpj)
      REAL, PUBLIC :: akw3(jpi,jpj,jpk)
!!
!!----------------------------------------------------------------------
!!
!! COMMON/cchem3/ : Variable for chemistry of the CO2 cycle
!!
!! ---------------------------------------------------------------------
!!
!!      VARIABLE           TYPE    PURPOSE.
!!      --------           ----    --------
!!
!!      *THIRD*            REAL    1./3. HALF PRECISION
!!      *THOUSI*           REAL    0.001 HALF PRECICION
!!      *SMICR*            REAL    1E-6 HALF PRECISION
!!      *SALCHL*           REAL    CONVERSION FACTOR TO CALCULATE CHLORID
!!                                 CONCENTRATION
!!                                 S(O/OO)=1.80655*CL(O/OO)
!!                                 KALLE/DIETRICH , P. 60, OR
!!                                 WOOSTER ET AL., 1969.
!!      *TEMZER*           REAL    ZERO DEG C EXPRESSED AS ABS. TEMPERATURE
!!                                 (DEG KELVIN)
!!      *PERC*             REAL    0.01 HALF PRECISION
!!      *AKCC1*            REAL    COEFFICIENT FOR EMPIRICALLY DETERMINED
!!                                 APPARENT SOLUBILITY PRODUCT K'SP OF
!!                                 CALCITE (INGLE, 1800, EQ. 6)
!!                                 (CF. BROECKER ET AL., 1982)
!!      *AKCC2*            REAL    COEFFICIENT FOR EMPIRICALLY DETERMINED
!!                                 APPARENT SOLUBILITY PRODUCT K'SP OF
!!                                 CALCITE (INGLE, 1800, EQ. 6)
!!                                 (CF. BROECKER ET AL., 1982)
!!      *AKCC3*            REAL    COEFFICIENT FOR EMPIRICALLY DETERMINED
!!                                 APPARENT SOLUBILITY PRODUCT K'SP OF
!!                                 CALCITE (INGLE, 1800, EQ. 6)
!!                                 (CF. BROECKER ET AL., 1982)
!!      *AKCC4*            REAL    COEFFICIENT FOR EMPIRICALLY DETERMINED
!!                                 APPARENT SOLUBILITY PRODUCT K'SP OF
!!                                 CALCITE (INGLE, 1800, EQ. 6)
!!                                 (CF. BROECKER ET AL., 1982)
!!      *ARAFRA*           REAL    FRACTION OF ARAGONITE IN BIOGENIC CACO3
!!                                 PARTICLES (E.G. 0.3 FOR 30 PERCENT)
!!      *CALFRA*           REAL    FRACTION OF CALCITE IN BIOGENIC CACO3
!!                                 PARTICLES (E.G. 0.3 FOR 30 PERCENT)
!!      *ARACAL*           REAL    FACTOR TO CONVERT APP. CALCITE SOLUBILITY
!!                                 PRODUCT (0 DBAR) TO THE APP. SOLUBILITY
!!                                 PRODUCT OF ARAGONITE (BERNER, 1976;
!!                                 CF. BROECKER ET AL., 1982)
!!      *DEVK1*            REAL    COEFFICIENT FOR SEAWATER PRESSURE CORRECTION
!!                                 OF 1. DISSOCIATION CONSTANT OF CARBONIC
!!                                 ACID AFTER CULBERSON AND PYTKOWICZ, 1968
!!                                 (CF. BROECKER ET AL., 1982)
!!      *DEVK2*            REAL    COEFFICIENT FOR SEAWATER PRESSURE CORRECTION
!!                                 OF 2. DISSOCIATION CONSTANT OF CARBONIC
!!                                 ACID AFTER CULBERSON AND PYTKOWICZ, 1968
!!                                 (CF. BROECKER ET AL., 1982)
!!      *DEVKB*            REAL    COEFFICIENT FOR SEAWATER PRESSURE CORRECTION
!!                                 OF 1. DISSOCIATION CONSTANT OF BORIC
!!                                 ACID AFTER CULBERSON AND PYTKOWICZ, 1968
!!                                 (CF. BROECKER ET AL., 1982)
!!      *DEVK1T*           REAL    COEFFICIENT FOR SEAWATER PRESSURE CORRECTION
!!                                 OF FIRST DISSOCIATION CONSTANT OF CARBONIC
!!                                 ACID AFTER CULBERSON AND PYTKOWICZ, 1968
!!                                 (CF. BROECKER ET AL., 1982)
!!      *DEVK2T*           REAL    COEFFICIENT FOR SEAWATER PRESSURE CORRECTION
!!                                 OF SECOND DISSOCIATION CONSTANT OF CARBONIC
!!                                 ACID AFTER CULBERSON AND PYTKOWICZ, 1968
!!                                 (CF. BROECKER ET AL., 1982)
!!      *DEVKBT*           REAL    COEFFICIENT FOR SEAWATER PRESSURE CORRECTION
!!                                 OF DISSOCIATION CONSTANT OF BORIC
!!                                 ACID AFTER CULBERSON AND PYTKOWICZ, 1968
!!                                 (CF. BROECKER ET AL., 1982)
!!      *DEVKS*            REAL    COEFFICIENT FOR PRESSURE CORRECTION OF
!!                                 SOLUBILITY PRODUCT OF CALCITE OR ARAGONITE
!!                                 AFTER EDMOND AND GIESKES (1970), P. 1285
!!                                 (REFERENCE TO CULBERSON AND PYTKOWICZ, 1968,
!!                                 AS DONE IN BROECKER ET AL., 1982, IS
!!                                 NOT CORRECT)
!!      *DEVKST*           REAL    COEFFICIENT FOR PRESSURE CORRECTION OF
!!                                 SOLUBILITY PRODUCT OF CALCITE OR ARAGONITE
!!                                 AFTER EDMOND AND GIESKES (1970), P. 1285,
!!                                 IN TERM WITH TEMPERATURE
!!                                 (REFERENCE TO CULBERSON AND PYTKOWICZ, 1968,
!!                                 AS DONE IN BROECKER ET AL., 1982, IS
!!                                 NOT CORRECT)
!!      *RGAS*             REAL    UNIVERSAL GAS CONSTANT (BOLTZMANN'S CONSTANT
!!                                 TIMES AVOGADRO'S CONSTANT =
!!                                 1.3804E-16*6.023*10E+23=8.3143E+7 ERG/GRD*MOL=
!!                                 83.143E+6 ERG/GRD*MOL=8.3143 J/K*MOL)
!!                                 MULTIPLIED WITH 10 (TO ACCOUNT FOR
!!                                 CHANGE FROM BAR TO DBAR)
!!                                 (CF. EDMOND AND GIESKES, 1970. P. 1285,
!!                                 BROECKER ET AL., 1982, P. 79)
!!      *BOR1*             REAL    TOTAL BORON CONTENT IN G/KG AT CL=19 O/OO
!!                                 (S=35)
!!                                 (CF. RILEY AND SKIRROW, VOL. 1, P. 648)
!!      *BOR2*             REAL    INVERSE OF ATOMIC WEIGHT OF BORON FOR
!!                                 CONVERTING SPECIFIC TOTAL BORATE IN
!!                                 CONCENTRATIONS
!!      *OXYCO*            REAL    INVERS OF NORMAL MOLAL VOLUME OF AN
!!                                 IDEAL GAS [CM**-3]
!!      *C00*              REAL    VOLUMETRIC SOLUBILITY CONSTANT A1 FOR
!!                                 THE SOLUBILITY OF CO2 IN ML/L FROM AIR
!!                                 AT ONE ATMOSPHERE (WEISS, 1974)
!!      *C01*              REAL    VOLUMETRIC SOLUBILITY CONSTANT A2 FOR
!!                                 THE SOLUBILITY OF CO2 IN ML/L FROM AIR
!!                                 AT ONE ATMOSPHERE (WEISS, 1974)
!!      *C02*              REAL    VOLUMETRIC SOLUBILITY CONSTANT A3 FOR
!!                                 THE SOLUBILITY OF CO2 IN ML/L FROM AIR
!!                                 AT ONE ATMOSPHERE (WEISS, 1974)
!!      *C03*              REAL    VOLUMETRIC SOLUBILITY CONSTANT B1 FOR
!!                                 THE SOLUBILITY OF CO2 IN ML/L FROM AIR
!!                                 AT ONE ATMOSPHERE (WEISS, 1974)
!!      *C04*              REAL    VOLUMETRIC SOLUBILITY CONSTANT B2 FOR
!!                                 THE SOLUBILITY OF CO2 IN ML/L FROM AIR
!!                                 AT ONE ATMOSPHERE (WEISS, 1974)
!!      *C05*              REAL    VOLUMETRIC SOLUBILITY CONSTANT B3 FOR
!!                                 THE SOLUBILITY OF CO2 IN ML/L FROM AIR
!!                                 AT ONE ATMOSPHERE (WEISS, 1974)
!!      *C10*              REAL    COEFF. FOR 1. H2CO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *C11*              REAL    COEFF. FOR F1. H2CO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *C12*              REAL    COEFF. FOR 1. H2CO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *C13*              REAL    COEFF. FOR 1. H2CO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *C20*              REAL    COEFF. FOR 2. H2CO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *C21*              REAL    COEFF. FOR 2. H2CO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *C22*              REAL    COEFF. FOR 2. H2CO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *C23*              REAL    COEFF. FOR 2. H2CO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *CB0*              REAL    COEFF. FOR 1. H3BO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *CB1*              REAL    COEFF. FOR 1. H3BO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *CB2*              REAL    COEFF. FOR 1. H3BO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *CB3*              REAL    COEFF. FOR 1. H3BO3 DISSOC. CONST. AFTER
!!                                 EDMOND AND GIESKES (1970)
!!      *CW0*              REAL    COEFF. FOR KW (DICKSON AND RILEY, 1979)
!!      *CW1*              REAL    COEFF. FOR KW (DICKSON AND RILEY, 1979)
!!      *CW2*              REAL    COEFF. FOR KW (DICKSON AND RILEY, 1979)
!!                                 (CORRECTED ACCORDING TO B. BACASTOW,
!!                                 PERS. COMMUN., 1988)
!!      *OX0*              REAL    VOLUMETRIC SOLUBILITY CONSTANT A1 FOR
!!                                 THE SOLUBILITY OF OXYGEN IN ML/L FROM
!!                                 MOIST AIR AT ONE ATMOSPHERE (WEISS, 1970)
!!      *OX1*              REAL    VOLUMETRIC SOLUBILITY CONSTANT A2 FOR
!!                                 THE SOLUBILITY OF OXYGEN IN ML/L FROM
!!                                 MOIST AIR AT ONE ATMOSPHERE (WEISS, 1970)
!!      *OX2*              REAL    VOLUMETRIC SOLUBILITY CONSTANT A3 FOR
!!                                 THE SOLUBILITY OF OXYGEN IN ML/L FROM
!!                                 MOIST AIR AT ONE ATMOSPHERE (WEISS, 1970)
!!      *OX3*              REAL    VOLUMETRIC SOLUBILITY CONSTANT A4 FOR
!!                                 THE SOLUBILITY OF OXYGEN IN ML/L FROM
!!                                 MOIST AIR AT ONE ATMOSPHERE (WEISS, 1970)
!!      *OX4*              REAL    VOLUMETRIC SOLUBILITY CONSTANT B1 FOR
!!                                 THE SOLUBILITY OF OXYGEN IN ML/L FROM
!!                                 MOIST AIR AT ONE ATMOSPHERE (WEISS, 1970)
!!      *OX5*              REAL    VOLUMETRIC SOLUBILITY CONSTANT B2 FOR
!!                                 THE SOLUBILITY OF OXYGEN IN ML/L FROM
!!                                 MOIST AIR AT ONE ATMOSPHERE (WEISS, 1970)
!!      *OX6*              REAL    VOLUMETRIC SOLUBILITY CONSTANT B3 FOR
!!                                 THE SOLUBILITY OF OXYGEN IN ML/L FROM
!!                                 MOIST AIR AT ONE ATMOSPHERE (WEISS, 1970)
!!      *T*                REAL    DUMMY VARIABLE, ABSOLUTE SEAWATER TEMP.
!!      *qtt*                REAL    DUMMY VARIABLE, ABSOLUTE SEAWATER TEMP.,
!!                                 DIVIDED BY 100.
!!      *S*                REAL    DUMMY VARIABLE, SALINITY
!!      *CL*               REAL    CHLORINITY (CL(O/OO)=S(O/OO)/1.80655)
!!                                 AFTER WOOSTER ET AL., 1969
!!                                 (C.F. KALLE/DIETRICH , P. 60)
!!      *CEK0*             REAL    LN(K0), LOGARITHM OF CO2 SOLUBILITY IN
!!                                 SEAWATER IN VOLUMETRIC UNITS (EQ. 12 IN
!!                                 WEISS, 1974)
!!      *CK1*              REAL    PK1-VALUE (K1= 1. H2CO3 DISSOC. CONST..),
!!                                 AFTER EDMOND AND GIESKES (1970)
!!      *CK2*              REAL    PK2-VALUE (K2= 2. H2CO3 DISSOC. CONST..),
!!                                 AFTER EDMOND AND GIESKES (1970)
!!      *CKB*              REAL    PKB-VALUE (KB= 1. H3BO3 DISSOC. CONST..)
!!                                 AFTER EDMOND AND GIESKES (1970)
!!      *CKW*              REAL    PKW-VALUE (KW=H2O DISSOC. CONST.) AFTER
!!                                 DICKSON AND RILEY (1979)
!!      *OXY*              REAL    LN(C*), LOGARITHM OF O2 SOLUBILITY IN
!!                                 SEAWATER IN VOLUMETRIC UNITS (EQ. 4 IN
!!                                 WEISS, 1970)
!!      *AK1*              REAL    K1, 1. H2CO3 DISSOC. CONSTANT
!!                                 (EDMOND AND GIESKES, 1970)
!!      *AK2*              REAL    K2, 2. H2CO3 DISSOC. CONSTANT
!!                                 (EDMOND AND GIESKES, 1970)
!!      *AKB*              REAL    KB, 1. H3BO3 DISSOC. CONSTANT
!!                                 (EDMOND AND GIESKES, 1970)
!!      *AKW*              REAL    KW, H2O DISSOC. CONSTANT, LIT ?
!!      *AK0*              REAL    EXP(LN(K0))=K0 CO2 SOLUBILITY IN SEAWATER
!!                                 IN VOLUMETRIC UNITS (ML/L)(WEISS, 1974,
!!                                 CF. EQ. 12)
!!      *RRR*              REAL    SIGMA-T IN OCEAN MODEL, DUMMY VARIABLE
!!                                 (USED FOR CALCULATION OF TOTAL BORAT
!!                                 CONCENTRATION) (SIGMA-T=RHO(S,T,0)/1000.)
!!      *BOR*              REAL    TOTAL BORAT CONCENTRATION , DUMMY VAR.
!!      *P*                REAL    APPROXIMATE PRESSURE AT DEPTH OF U-POINTS
!!                                 IN BAR, DUMMY VARIABLE
!!      *AKSP0*            REAL    CACO3 SOLUBILITY PRODUCT AT P=0 DBAR
!!                                 ACCORDING TO INGLE (1800), EQ. 6; THE
!!                                 CITATION OF CULBERSON AND PYTKOWICZ, 1968,
!!                                 IN BROECKER ET AL., 1982, IS PRESUMABLY
!!                                 NOT CORRECT)
!!      *AKSP(jpi,jpj,jpk)*   REAL    CACO3 SOLUBILITY PRODUCT AT IN SITU PRESSURE
!!                                 FOLLOWING THE PROCEDURE DESCRIBED IN EDMOND
!!                                 AND GIESKES (1970), P. 1285
!!      *CP*               REAL    TERM IN EXPONENT OF EQUATIONS FOR PRESSURE
!!                                 CORRECTION OF DISSOC. CONSTANTS (CARB.,
!!                                 BOR. ACID) AND CALCITE SOLUB. PRODUCT
!!                                 (CF. BROECKER ET AL., 1982, EDMOND AND
!!                                 GIESKES, 1970)
!!      *TC*               REAL    TEMPERATURE AT OCEAN GRID POINTS (DEG C),
!!                                 DUMMY VARIABLE
!!      *KI*               INTEGER COUNTS ITERATIONS FOR NEWTON-RAPHSON METHOD
!!                                 FOR INITIATION OF [CO3--] AND [H+]
!!      *H*                REAL    [H+], DUMMY VARIABLE
!!      *R*                REAL    [CO3--] [MOLE/L], DUMMY VARIABLE
!!      *ALKA*             REAL    GIVEN ALKALINITY [EQV/L], DUMMY VARIABLE
!!      *C*                REAL    GIVEN [SUM(12C)O2] [MOLE/L], DUMMY VARIABLE
!!      *A*                REAL    ALKALINITY [EQV/L] AS FUNCTION OF [CO3--]
!!                                 AND [H+], DUMMY VARIABLE
!!      *DCDS*             REAL    LOCAL DERIVATIVE
!!                                 [SUM(CO2)]([CO3--],H+]) -> [CO3--]
!!      *DADS*             REAL    LOCAL DERIVATIVE
!!                                 [ALK]([CO3--],H+]) -> [CO3--]
!!      *DCDH*             REAL    LOCAL DERIVATIVE
!!                                 [SUM(CO2)]([CO3--],H+]) -> [H+]
!!      *DADH*             REAL    LOCAL DERIVATIVE
!!                                 [ALK]([CO3--],H+]) -> [H+]
!!      *F*                REAL    FUNCTION [ALK] GIVEN MINUS [ALK] IN TERMS
!!                                 OF [CO3--] AND [H+]
!!      *CC*               REAL    [SUM(CO2)] [MOLE/L] AS FUNCTION OF
!!                                 [CO3--] AND [H+], DUMMY VARIABLE
!!      *GG*               REAL    FUNCTION [SUM(CO2)] GIVEN MINUS [SUM(CO2)]
!!                                 IN TERMS OF [CO3--] AND [H+]
!!      *DETI*             REAL    DETERMINANT WITH LOCAL DERIVATIVES FOR
!!                                 NEWTON-RAPHSON ITERATION
!!
      REAL, PUBLIC :: akcc1, akcc2, akcc3, akcc4
      REAL, PUBLIC :: arafra, calfra, aracal, devk1, devk2, devkb
      REAL, PUBLIC :: devk1t, devk2t, devkbt, devkst, devks
      REAL, PUBLIC :: bor1, bor2, c00, c01, c02, c03, c04, c05, c10, c11
      REAL, PUBLIC :: c12, c13, c20, c21, c22, c23, cb0, cb1, cb2, cb3
      REAL, PUBLIC :: c14, c15, c16, c17, c24, c25, c26, c27
      REAL, PUBLIC :: cb4, cb5, cb6, cb7, cb8, cb9, cb10, cb11
      REAL, PUBLIC :: cw3, cw4, cw5, cw6
      REAL, PUBLIC :: cw0, cw1, cw2, ox0, ox1, ox2, ox3, ox4
      REAL, PUBLIC :: cek0, ckb, ck1, ck2, ckw, ak1, ak2, ak0
      REAL, PUBLIC :: bor, aksp0, ah
      REAL, PUBLIC :: smicr, thousi, perc, third
      REAL, PUBLIC :: salchl, temzer, rgas, oxyco, ox5
      REAL, PUBLIC :: oxy, rrr
      REAL, PUBLIC :: qtt
      REAL, PUBLIC :: chemc(jpi,jpj,4), cpexp
!!
!!----------------------------------------------------------------------
!!
!! COMMON/cotcon/ : Time variables
!!
!! ---------------------------------------------------------------------
!!
      REAL, PUBLIC :: rfact, rfactr, xtvit
!!
!!----------------------------------------------------------------------
!!
!! COMMON/cotgas/ : Gas exchange
!!
!! ---------------------------------------------------------------------
!!
      REAL, PUBLIC :: qcumul(jptra)
      REAL, PUBLIC :: kgwanin(jpi,jpj)
#if defined key_trc_atmco2
!
!!----------------------------------------------------------------------
!!
!! COMMON/pertco2/ : read real atmospheric CO2 data
!!
!! -----------------------------------------------------------------
!!
      INTEGER, PUBLIC, PARAMETER :: nmaxrec=4201
      REAL, PUBLIC :: yrco2(nmaxrec),sipco2(nmaxrec),pco2at,sipn2o(nmaxrec),pn2oat
      INTEGER, PUBLIC :: nutatm
#endif
!!----------------------------------------------------------------------
!!
!! COMMON/cotnam/ : biogeochemical parameters in namelist.trc.sms
!!
!! ---------------------------------------------------------------------
!! rn_km?phy = MICHAELIS MENTEN CONSTANTS OF PRODUCTIVITY (HALF SATU-
!!             RATION CONSTANT; NUTRIENT CONCENTRATION, WHERE NUTRIENT
!!             UPTAKE VELOCITY IS HALF ITS POTENTIAL MAXIMUM VALUE;
!!             MICHAELIS & MENTEN(1913)
!! rn_coccal = ratio c-c(organic)/c-cacao3 in biogenic particles
!! rn_lyscal = inertia concentration of caco3 for spontaneous dissolution 
!!             [moles/l]
!!
!! aggregation parameters
!!
      REAL, PUBLIC :: rn_ag1poc,rn_ag2poc,rn_ag3poc,rn_ag4poc,rn_ag5doc,rn_ag6doc
      REAL, PUBLIC :: rn_singoc,rn_snkgoc,rn_snkpoc
!!
!! river fluxes
!!
      REAL, PUBLIC :: rn_rivdic,rn_rivdoc,rn_rivfer,rn_rivnit,rn_rivpo4,rn_rivpoc,rn_rivsil
!!
!! Fe parameters
!!
      REAL, PUBLIC :: rn_fersol,rn_sedfer,rn_scofer,rn_scmfer,rn_ligfer
!!
!! biological parameters for preferences 
!!
      REAL, PUBLIC :: rn_gmibac,rn_gmipoc,rn_gmigoc
      REAL, PUBLIC :: rn_gmebac,rn_gmepoc,rn_gmegoc,rn_gmemic
      REAL, PUBLIC :: rn_gmabac,rn_gmapoc,rn_gmagoc,rn_gmamic,rn_gmames
      REAL, PUBLIC :: rn_gbadoc,rn_gbapoc,rn_gbagoc
      REAL, PUBLIC :: rn_gmiphy(jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: rn_gmephy(jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: rn_gmaphy(jpdia:jpdia+jppft-1) 
!!
!! biological parameters for heterotrophs 
!!
      REAL, PUBLIC :: rn_doxden
      REAL, PUBLIC :: rn_ggebac,rn_ggtbac,rn_ggemic,rn_ggtmic,rn_ggemes,rn_ggemac
      REAL, PUBLIC :: rn_sigmic,rn_sigmes,rn_sigmac
      REAL, PUBLIC :: rn_unamic,rn_unames,rn_unamac
      REAL, PUBLIC :: rn_grabac,rn_gramic,rn_grames,rn_gramac
      REAL, PUBLIC :: rn_kmobac,rn_grkmic,rn_grkmes,rn_grkmac
      REAL, PUBLIC :: rn_grmbac,rn_grmmic,rn_grmmes,rn_grmmac
      REAL, PUBLIC :: rn_kmfbac,rn_kmpbac
      REAL, PUBLIC :: rn_mormes,rn_mormac,rn_motmes,rn_motmac
      REAL, PUBLIC :: rn_resbac,rn_resmic,rn_resmes,rn_resmac
      REAL, PUBLIC :: rn_retbac,rn_retmic,rn_retmes,rn_retmac
      REAL, PUBLIC :: rn_icemac,rn_trnmac,rn_coazoo
!!
!! biological parameters for phytoplankton 
!!
      REAL, PUBLIC :: rn_coccal,rn_discal,rn_kmsbsi
      REAL, PUBLIC :: rn_lyscal,rn_sildia,rn_munfix
      REAL, PUBLIC :: rn_faco18
      REAL, PUBLIC :: rn_tordoc, rn_nutthe
      REAL, PUBLIC :: rn_aggphy
      REAL, PUBLIC :: rn_resphy(jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: rn_docphy(jpdia:jpdia+jppft-1),rn_domphy(jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: rn_kmnphy(jpdia:jpdia+jppft-1),rn_kmpphy(jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: rn_mumpft(jpdia:jpdia+jppft-1)
!!
!! temperature-dependence for all PFTs
!!
      REAL, PUBLIC :: rn_mutpft(jpmic:jpdia+jppft)
!!
!! parameters for the Fe-light model 
!!
      REAL, PUBLIC :: rn_kmfphy(jpdia:jpdia+jppft-1), rn_rhfphy(jpdia:jpdia+jppft-1)      
      REAL, PUBLIC :: rn_qmaphy(jpdia:jpdia+jppft-1), rn_qmiphy(jpdia:jpdia+jppft-1)    
      REAL, PUBLIC :: rn_qopphy(jpdia:jpdia+jppft-1)
!!
!! other light parameters 
!!
      REAL, PUBLIC :: rn_ekwgrn,rn_ekwred
      REAL, PUBLIC :: rn_alpphy(jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: rn_kgrphy(jpdia:jpdia+jppft-1),rn_krdphy(jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: rn_thmphy(jpdia:jpdia+jppft-1),rn_tliphy(jpdia:jpdia+jppft-1)    
!!
!! parameters for the DMS model
!!
      REAL, PUBLIC :: rn_dmsyld, rn_etomax
      REAL, PUBLIC :: rn_rdddms 
      REAL, PUBLIC :: rn_xcldmd, rn_xpodms
      REAL, PUBLIC :: rn_xkdms, rn_xkdmd
      REAL, PUBLIC :: rn_assdms(2)
      REAL, PUBLIC :: rn_rphdmd(jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: rn_xpldmd(jpdia:jpdia+jppft-1)
!! parameters for N2O
      INTEGER, PUBLIC :: nn_deun2s
      REAL, PUBLIC :: rn_kmhphy(jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: rn_aoun2o,rn_aoun2s,rn_atmn2o,rn_betn2s,rn_decn2s
      REAL, PUBLIC :: rn_degn2o,rn_degn2b,rn_denn2b,rn_denn2o,rn_doxn2o
      REAL, PUBLIC :: rn_degn2a,rn_degn2c,rn_denn2a,rn_denn2c
      REAL, PUBLIC :: rn_degn2d,rn_degn2e,rn_denn2d,rn_denn2e
      REAL, PUBLIC :: rn_lign2o,rn_nitnh4,rn_omxn2s
!!
!!----------------------------------------------------------------------
!!
!! COMMON/cotham/ : biological parameters inherited from HAMOCC3
!!
!! ---------------------------------------------------------------------
!!
!! calcon = MEAN TOTAL [CA++] IN SEAWATER (MOLES/KG) 
!!             (SEE BROECKER A. PENG, 1982, P. 26)
!!             ([CA++](MOLES/KG)=1.026E-2*(S/35.) AFTER
!!             CULKIN(1965), CF. BROECKER ET AL. 1982)
!! alknut = REDFIELD RATIO MOLES N + TPO4 / MOLES C
!!             (FOR CHANGE IN ALKALINITY DUE TO PRODUCTION/REMINE-
!!             RALIZATION OF ORGANIC MATTER)
!!             N:C=16:122, SEE Wolf-Gladrow et al. 2007
!!
!!             COMPOSITION OF PLANKTONIC MATERIAL AND RESPIRATION:
!!             C106H263O110N16P + 138 O2 ->
!!            -> 106 CO2 + 16 NO3- + HPO4(2-) + 122 H2O + 18 H+  ,
!!             SEE DEGENS ET AL. (1984), P. 152
!!      *PO4R*      REAL  RATIO (MOLES P)/(MOLES C) (REDFIELD RATIO P:C)
!! ---------------------------------------------------------------------
!! 
      REAL, PUBLIC :: alknut,rata2h,ratn2c,ratc2n,rato2c,rato2n,po4r
      REAL, PUBLIC :: calcon, plafr13, pdb, minfer
      REAL, PUBLIC :: zmeu(jpi,jpj),denitr(jpi,jpj,jpk)
      REAL, PUBLIC :: prcaca(jpi,jpj,jpk),prorca3(jpi,jpj,jpk)
      REAL, PUBLIC :: dust(jpi,jpj),dustmo(jpi,jpj,12)
      REAL, PUBLIC :: tgfunc(jpi,jpj,jpk,jpmic:jpdia+jppft)
      REAL, PUBLIC :: atmnoy(jpi,jpj,14),atmnhx(jpi,jpj,14),atmdon(jpi,jpj,12)
      REAL, PUBLIC :: depdic(jpi,jpj,jpk),depdoc(jpi,jpj,jpk),deppoc(jpi,jpj,jpk)
      REAL, PUBLIC :: depnit(jpi,jpj,jpk),deppo4(jpi,jpj,jpk),depsil(jpi,jpj,jpk)
      REAL, PUBLIC :: depnh4(jpi,jpj,jpk),depno3(jpi,jpj,jpk),depfer(jpi,jpj,jpk)
      REAL, PUBLIC :: atmdin(jpi,jpj,jpk)
      REAL, PUBLIC :: extinp(5),sedcor(5),seddep(7)
!!
!!----------------------------------------------------------------------
!!
!! COMMON/cotbio/ : biological parameters inherited from PISCES
!!
!!----------------------------------------------------------------------
!!
      REAL, PUBLIC :: sinking2(jpi,jpj,jpk),sinkcal(jpi,jpj,jpk),delo2(jpi,jpj,jpk)
      REAL, PUBLIC :: etot(jpi,jpj,jpk)
      REAL, PUBLIC :: sinking(jpi,jpj,jpk),sinkfer(jpi,jpj,jpk)
      REAL, PUBLIC :: sinkfer2(jpi,jpj,jpk)
      REAL, PUBLIC :: xagg(jpi,jpj,jpk),xaggfe(jpi,jpj,jpk)
      REAL, PUBLIC :: xaggdoc(jpi,jpj,jpk)
      REAL, PUBLIC :: bactge(jpi,jpj,jpk)
      REAL, PUBLIC :: xscave(jpi,jpj,jpk),olimi(jpi,jpj,jpk)
      REAL, PUBLIC :: orem(jpi,jpj,jpk),orem2(jpi,jpj,jpk)
      REAL, PUBLIC :: ofer(jpi,jpj,jpk),ofer2(jpi,jpj,jpk)
      REAL, PUBLIC :: osil(jpi,jpj,jpk),xaggdoc2(jpi,jpj,jpk)
      REAL, PUBLIC :: sinksil(jpi,jpj,jpk)
!!
!!----------------------------------------------------------------------
!!
!! COMMON/cotgom/ : biological parameters specific to PlankTOM
!!
!!----------------------------------------------------------------------
!!
      REAL, PUBLIC :: dnsmin,ferat3
      REAL, PUBLIC :: grabac(jpi,jpj,jpk),grafer(jpi,jpj,jpk)
      REAL, PUBLIC :: grafer2(jpi,jpj,jpk),grafer3(jpi,jpj,jpk)
      REAL, PUBLIC :: gramac(jpi,jpj,jpk,jpdia:jpdia+jppft-1,3),gramat(jpi,jpj,jpk)
      REAL, PUBLIC :: grames(jpi,jpj,jpk,jpdia:jpdia+jppft-1,3),gramet(jpi,jpj,jpk)
      REAL, PUBLIC :: gramic(jpi,jpj,jpk,jpdia:jpdia+jppft-1,3),gramit(jpi,jpj,jpk)
      REAL, PUBLIC :: grapoc(jpi,jpj,jpk),grapoc2(jpi,jpj,jpk),grapoc3(jpi,jpj,jpk)
      REAL, PUBLIC :: tordoc(jpi,jpj,jpk),torpoc(jpi,jpj,jpk),torgoc(jpi,jpj,jpk)
      REAL, PUBLIC :: grarem(jpi,jpj,jpk),grarem2(jpi,jpj,jpk),grarem3(jpi,jpj,jpk)
      REAL, PUBLIC :: gramam(jpi,jpj,jpk),gramaz(jpi,jpj,jpk),grambac(jpi,jpj,jpk)
      REAL, PUBLIC :: grampoc(jpi,jpj,jpk),gramgoc(jpi,jpj,jpk),gramgof(jpi,jpj,jpk),grampof(jpi,jpj,jpk)
      REAL, PUBLIC :: grazg(jpi,jpj,jpk),grazgf(jpi,jpj,jpk)
      REAL, PUBLIC :: grazm(jpi,jpj,jpk),grazmf(jpi,jpj,jpk)
      REAL, PUBLIC :: grazbac(jpi,jpj,jpk)
      REAL, PUBLIC :: grazpoc(jpi,jpj,jpk),grazpof(jpi,jpj,jpk)
      REAL, PUBLIC :: grazgoc(jpi,jpj,jpk),grazgof(jpi,jpj,jpk)
      REAL, PUBLIC :: grazs(jpi,jpj,jpk),grazss(jpi,jpj,jpk),grazz(jpi,jpj,jpk),grasss(jpi,jpj,jpk)
      REAL, PUBLIC :: irondep(jpi,jpj,jpk),sidep(jpi,jpj,jpk)
      REAL, PUBLIC :: macrge(jpi,jpj,jpk),mesoge(jpi,jpj,jpk),micrge(jpi,jpj,jpk)
      REAL, PUBLIC :: docphy(jpi,jpj,jpk,jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: pnophy(jpi,jpj,jpk,jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: prophy(jpi,jpj,jpk,jpdia:jpdia+jppft-1,3)
      REAL, PUBLIC :: resphy(jpi,jpj,jpk,jpdia:jpdia+jppft-1,3)
      REAL, PUBLIC :: resps(jpi,jpj,jpk),resbac(jpi,jpj,jpk),morbac(jpi,jpj,jpk)
      REAL, PUBLIC :: scamld(jpi,jpj,jpk),scabfe(jpi,jpj,jpk),scasfe(jpi,jpj,jpk)
      REAL, PUBLIC :: respz(jpi,jpj,jpk),respz2(jpi,jpj,jpk),respz3(jpi,jpj,jpk)
      REAL, PUBLIC :: tormic(jpi,jpj,jpk),tormes(jpi,jpj,jpk),tormac(jpi,jpj,jpk)
      REAL, PUBLIC :: trno2(jpi,jpj,jpk)
      REAL, PUBLIC :: rbafer(jpi,jpj,jpk),ubafer(jpi,jpj,jpk)
      REAL, PUBLIC :: dinpft(jpi,jpj,jpk,jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: xlimbac(jpi,jpj,jpk)
      REAL, PUBLIC :: volumt(jpi,jpj,jpk),rcoast(jpi,jpj)
      REAL, PUBLIC :: trnmac(jpi,jpj)
      REAL, PUBLIC :: extpar(jpi,jpj,jpk),alpthe(jpi,jpj,jpk)
!!
!!-----------------------------------------------------------------
!!
!!    COMMON/cotdms/: for the prognostic DMS model by Meike
!!
!!----------------------------------------------------------------
!!
      REAL, PUBLIC :: prodms(jpi,jpj,jpk), prodmd(jpi,jpj,jpk)
      REAL, PUBLIC :: degdms(jpi,jpj,jpk), degdmd(jpi,jpj,jpk)
      REAL, PUBLIC :: dmddms(jpi,jpj,jpk)
      REAL, PUBLIC :: dmspp(jpi,jpj,jpk)
      REAL, PUBLIC :: rphdmd(jpi,jpj,jpk,jpdia:jpdia+jppft-1)
      REAL, PUBLIC :: dms_snkcount,dmd_snkcount

      REAL, PUBLIC :: torphy(jpi,jpj,jpk,jpdia:jpdia+jppft-1,3)
      REAL, PUBLIC :: torts(jpi,jpj,jpk)
      REAL, PUBLIC :: pown2s(jpi,jpj),divn2s(jpi,jpj)
#endif
END MODULE sms
